
proc nclearall {} {
   for {set x 1} {$x <= 9} {incr x} {
      for {set y 1} {$y <= 9} {incr y} {
         .n.grid.t$x$y delete 0.0 end
         .n.grid.t$x$y configure -foreground black
         .n.scratch.t delete 0.0 end
         .n.scratch.t insert end "Finished:  "
      }
   }
}


proc setnotes {b a} {
   global grid
   if {$grid($a$b) == ""} { return }

   set fl [list 0 a b c d e f g h i]
   set x [lsearch $fl $a]
   set y [lsearch $fl $b]

   .n.grid.t$x$y delete 0.0 end
   .n.grid.t$x$y insert 0.0 $grid($a$b)
   .n.grid.t$x$y configure -foreground black
}

proc nnext {c} {
   incr c ; if {$c == 10} { set c 1 }
   return $c
}

proc nprev {c} {
   incr c -1 ; if {$c == 0} { set c 9 }
   return $c
}


proc nkeyleft {} {
   set current [focus]
   if {[regexp {.n.grid.t([1-9])([1-9])} $current a x y]} {
      focus .n.grid.t[nprev $x]$y
   } else {
      focus .n.grid.t11
   }
}

proc nkeyright {} {
   set current [focus]
   if {$current == ""} { focus .n.grid.t11 ; return }
   if {[regexp {.n.grid.t([1-9])([1-9])} $current a x y]} {
      focus .n.grid.t[nnext $x]$y
   } else {
      focus .n.grid.t11
   }
}


proc nkeyup {} {
   set current [focus]
   if {[regexp {.n.grid.t([1-9])([1-9])} $current a x y]} {
      focus .n.grid.t$x[nprev $y]
   } else {
      focus .n.grid.t11
   }
}

proc nkeydown {} {
   set current [focus]
   if {$current == ""} { focus .n.grid.t11 ; return }
   if {[regexp {.n.grid.t([1-9])([1-9])} $current a x y]} {
      focus .n.grid.t$x[nnext $y]
   } else {
      focus .n.grid.t11
   }
}

proc togglered {w} {
   set current [$w cget -foreground]
   if {$current == "red"} {
      $w configure -foreground black
   } else {
      $w configure -foreground red
   }
}


proc setredfill {w} {
   $w configure -foreground red
   $w delete 0.0 end
   $w insert end "123456789"
}


if {![winfo exists .n]} {

   toplevel .n
   pack [frame .n.grid] -side top -expand n
   set w .n.grid

   for {set x 1} {$x <= 9} {incr x} {
      for {set y 1} {$y <= 9} {incr y} {
         text $w.t$x$y -height 2 -width 6 -font {Times 12 bold}
         grid $w.t$x$y -row $y -column $x
      }
   }

   foreach x { 1 2 3 7 8 9 } {
      foreach y { 1 2 3 7 8 9 } { .n.grid.t$x$y configure -bg white }
      foreach y { 4 5 6 } { .n.grid.t$x$y configure -bg #d9d9d9 }
   }

   foreach x { 4 5 6 } {
      foreach y { 4 5 6 } { .n.grid.t$x$y configure -bg white }
      foreach y { 1 2 3 7 8 9 } { .n.grid.t$x$y configure -bg #d9d9d9 }
   }

   bind Text <Control-Key-Left> { nkeyleft }
   bind Text <Control-Key-Right> { nkeyright }
   bind Text <Key-Up> { nkeyup }
   bind Text <Key-Down> { nkeydown }
   bind Text <FocusIn> { %W configure -insertbackground red }
   bind Text <FocusOut> { %W configure -insertbackground white }
   bind Text <ButtonPress-2> { setredfill %W }
   bind Text <ButtonPress-3> { togglered %W }

   pack [frame .n.control] -side top -expand n
   set w .n.control

   button $w.clear -text "Clear all" -command { nclearall }
   pack $w.clear -side left -expand y -fill x

   pack [frame .n.scratch] -side top -expand n
   pack [text .n.scratch.t -height 3] -expand y -fill x
   .n.scratch.t configure -font {Times 10 bold } -width 68
   .n.scratch.t insert end "Finished:  "

   wm title .n "SudoNotes"
}


